﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private Button1 As Button
	Private Button2 As Button
	Private Button3 As Button
	Private Button4 As Button
	Private Button5 As Button
	Private Button6 As Button
	Private Pane1 As Pane
	Public cnvs As B4XCanvas
	Public buttonsmap As Map
	Public propsmap As Map
	Public btnsource As Button
	Public btndest As Button
	Public oldx As Double
	Public oldy As Double
	Public startx As Double
	Public starty As Double
	Public endx	As Double
	Public endy As Double
	Public finishdraw As Boolean
	Public mousedragged As Boolean
	Public direction As String
	Public linecollectionmap As Map
	Public linemap As Map
	Public keycnt As Int = 0
	Public buttonsactivated As Boolean
	Private cbxlinecount As B4XComboBox
	Public maxcnt As Int
	Private lblmessage As Label
	Private msg As String
	Private sourceselected As Boolean
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Connect the buttons")
	cnvs.Initialize(Pane1)
	buttonsmap.Initialize
	propsmap.Initialize
	btnsource.Initialize("")
	btndest.Initialize("")
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			propsmap = CreateMap("left":vw.Left,"top":vw.Top,"width":vw.Width,"height":vw.Height)
			buttonsmap.Put(vw.tag,propsmap)
		End If
	Next
	linecollectionmap.Initialize
	linemap.Initialize
	disable_buttons
	Dim lst As List = Array As Int(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)
	cbxlinecount.SetItems(lst)
	sourceselected = False
	msg = lblmessage.Text
	lblmessage.Text = msg & "(" & keycnt & ")"
End Sub
Private Sub disable_buttons
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			vw.Enabled = False
		End If
	Next
	buttonsactivated = False
End Sub
Private Sub enable_buttons
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			vw.Enabled = True
		End If
	Next
	buttonsactivated = True
End Sub
Private Sub remove_borders
	For Each vw As B4XView In Pane1.GetAllViewsRecursive
		If vw Is Button Then
			CSSUtils.SetBorder(vw,0,fx.Colors.Transparent,0)
		End If
	Next
End Sub
Private Sub Pane1_MouseClicked (EventData As MouseEvent)
	If EventData.SecondaryButtonPressed Then
		reset_canvas
		finishdraw = False
		mousedragged = False
		disable_buttons
		remove_borders
		btnsource.Initialize("")
		btndest.Initialize("")
		startx = 0
		starty = 0
		endx = 0
		endy = 0
		keycnt = 0
		linecollectionmap.Clear
		linemap.Clear
		EventData.Consume
		Return
	End If
End Sub
Private Sub Pane1_MousePressed (EventData As MouseEvent)
	If finishdraw = True Then Return
	If buttonsactivated = True Then Return
	mousedragged = False
	finishdraw = False
	Dim xpos As Double = EventData.X
	Dim ypos As Double = EventData.Y
	For Each key In buttonsmap.Keys
		propsmap = buttonsmap.Get(key)
		Dim left As Double = propsmap.Get("left")
		Dim top As Double = propsmap.Get("top")
		Dim width As Double = propsmap.Get("width")
		Dim height As Double = propsmap.Get("height")
		If xpos >= left And ypos >= top And xpos <= left+width And ypos <= top+height Then
			Dim name As String = key.As(String)
			Dim index As Int = name.SubString(name.Length-1)	' last character is button counter
			btnsource = Pane1.GetNode(index)					' node 0 is the canvas!
			CSSUtils.SetBorder(btnsource,3,fx.Colors.Blue,3)
			oldx = xpos
			oldy = ypos
			startx = xpos
			starty = ypos
			disable_buttons
			sourceselected = True
		End If
	Next
	If sourceselected = False Then
		reset_canvas
		mousedragged = False
		finishdraw = False
		startx = 0
		starty = 0
		endx = 0
		endy = 0
	End If
	EventData.Consume
End Sub
Private Sub Pane1_MouseDragged (EventData As MouseEvent)
	If startx = 0 And starty = 0 Then Return
	If finishdraw = True Then Return
	Dim xpos As Double = EventData.X
	Dim ypos As Double = EventData.Y
	cnvs.DrawLine(oldx,oldy,xpos,ypos,xui.Color_Blue,3)
	For Each key In buttonsmap.Keys
		propsmap = buttonsmap.Get(key)
		Dim left As Double = propsmap.Get("left")
		Dim top As Double = propsmap.Get("top")
		Dim width As Double = propsmap.Get("width")
		Dim height As Double = propsmap.Get("height")
		If xpos >= left And ypos >= top And xpos <= left+width And ypos <= top+height Then
			Dim name As String = key.As(String)
			Dim index As Int = name.SubString(name.Length-1)
			btndest = Pane1.GetNode(index)
			If btnsource.Tag <> btndest.Tag Then 
				CSSUtils.SetBorder(btndest,3,fx.Colors.Green,3)
				finishdraw = True
				mousedragged = True
				endx = xpos
				endy = ypos
				sourceselected = False
				Return
			End If
		End If
	Next
	oldx = xpos
	oldy = ypos
	EventData.Consume
End Sub
Private Sub Pane1_MouseReleased (EventData As MouseEvent)
	draw_lines
	If mousedragged = False Then Return
	If startx > 0 And starty > 0 And endx > 0 And endy > 0 And finishdraw = True Then
		reset_canvas
		If btnsource.IsInitialized = True And btndest.IsInitialized = True Then
			set_startpos_and_endpos
			Select direction
				Case "upperright"
					startx = btnsource.Left+btnsource.Width
					starty = btnsource.Top
					endx = btndest.left
					endy = btndest.Top+btndest.height
				Case "middleright"
					startx = btnsource.Left+btnsource.Width
					starty = btnsource.Top+(btnsource.Height/2)
					endx = btndest.left
					endy = btndest.Top+(btndest.height/2)
				Case "lowerright"
					startx = btnsource.Left+btnsource.Width
					starty = btnsource.Top+btnsource.Height
					endx = btndest.left
					endy = btndest.Top
				Case "upperleft"
					startx = btnsource.Left
					starty = btnsource.Top
					endx = btndest.left+btndest.Width
					endy = btndest.Top+btndest.height
				Case "middleleft"
					startx = btnsource.Left
					starty = btnsource.Top+(btnsource.Height/2)
					endx = btndest.left+btndest.Width
					endy = btndest.Top+(btndest.height/2)
				Case "lowerleft"
					startx = btnsource.Left
					starty = btnsource.Top+btnsource.Height
					endx = btndest.left+btndest.width
					endy = btndest.Top
				Case "up"
					startx = btnsource.Left+(btnsource.Width/2)
					starty = btnsource.Top
					endx = btndest.left+(btndest.Width/2)
					endy = btndest.Top+btndest.height
				Case "down"
					startx = btnsource.Left+(btnsource.Width/2)
					starty = btnsource.Top+btnsource.Height
					endx = btndest.left+(btndest.Width/2)
					endy = btndest.Top		
			End Select
			linemap = CreateMap("startx":startx,"starty":starty,"endx":endx,"endy":endy, _
								"color":xui.Color_Red,"strokewidth":2)
			linecollectionmap.Put(keycnt,linemap)
			keycnt = keycnt + 1
			draw_lines
			lblmessage.Text = msg & "(" & keycnt & ")"
'			remove_borders
		End If
	End If
	finishdraw = True
	mousedragged = False
	If keycnt > cbxlinecount.SelectedItem -1 Then
		enable_buttons
	Else
		finishdraw = False
	End If
	EventData.Consume
End Sub
Private Sub draw_lines
	For Each key In linecollectionmap.Keys
		Dim lmap As Map = linecollectionmap.Get(key)
		cnvs.DrawLine(lmap.Get("startx"),lmap.Get("starty"),lmap.Get("endx"),lmap.Get("endy"), _
					  lmap.Get("color"),lmap.Get("strokewidth"))
	Next
End Sub
Private Sub set_startpos_and_endpos
	' from the center of the buttons
	startx = btnsource.Left+(btnsource.Width/2)
	starty = btnsource.top+(btnsource.height/2)
	endx = btndest.Left+(btndest.Width/2)
	endy = btndest.top+(btndest.height/2)
	Log(startx & " " & starty & " " & endx & " " & endy)
	direction = ""
	Dim rect As B4XRect		' surrounding rectangle to determine the direction of the line
	Dim left As Int
	Dim top As Int
	Dim right As Int
	Dim bottom As Int
	If startx > endx Then
		left = endx
		right = startx
	Else
		left = startx
		right = endx
	End If
	If starty > endy Then
		top = endy
		bottom = starty
	Else
		top = starty
		bottom = endy
	End If
	rect.Initialize(left,top,right,bottom)
	Log("rect width: " & rect.Width)
	Log("rect height: " & rect.Height)
	If rect.Width > 70 Then
		If startx > endx Then	' left
			If rect.Height > 50 Then
				If starty > endy Then
					direction = "upperleft"
				Else
					direction = "lowerleft"
				End If
			Else
				direction = "middleleft"
			End If
		Else					' right
			If rect.Height > 50 Then
				If starty > endy Then
					direction = "upperright"
				Else
					direction = "lowerright"
				End If
			Else
				direction = "middleright"
			End If
		End If
	Else								' a narrow width means up or down
		If starty > endy Then	' up
			direction = "up"
		Else					'down
			direction = "down"	
		End If
	End If
	Log(direction)
End Sub
Private Sub reset_canvas
	Dim rect As B4XRect
	rect.Initialize(0,0,Pane1.Width+Pane1.Left,Pane1.Height+Pane1.Top)
	cnvs.ClearRect(rect)
End Sub
Private Sub Button1_Click
	xui.MsgboxAsync("button 1 clicked", "Button1")
End Sub
Private Sub Button2_Click
	xui.MsgboxAsync("button 2 clicked", "Button2")	
End Sub
Private Sub Button3_Click
	xui.MsgboxAsync("button 3 clicked", "Button3")	
End Sub
Private Sub Button4_Click
	xui.MsgboxAsync("button 4 clicked", "Button4")	
End Sub
Private Sub Button5_Click
	xui.MsgboxAsync("button 5 clicked", "Button5")	
End Sub
Private Sub Button6_Click
	xui.MsgboxAsync("button 6 clicked", "Button6")
End Sub
Private Sub cbxlinecount_SelectedIndexChanged (Index As Int)
	maxcnt = cbxlinecount.SelectedItem
End Sub